#include <mudlib.h>
inherit ROOM;

void reset(status arg) 
{
    object board;

    if(!present("board")) 
    {
	board = clone_object(BULLETIN_BOARD);
	board -> set_save_file("d/ooc/w/jheleg/ooc/board_save");
	board -> set_short("OOC Domain Board");
	move_object(board,this_object());
    }
    ::reset(arg);
    if(!arg) 
    {
	set_short("OOC Domain Lounge");
	set_long(
	  "  Huge oriental tapestries blanket the four stone walls that  \n"+
	  "  rise to meet a vaulted ceiling high above your head.  On the \n"+
	  "  south wall hangs four portraits of the people who have made  \n"+
	  "  OOCdom what it is.  The thick forest green carpet provides   \n"+
	  "  a perpetual cloud of fuzz on which to walk, negating the     \n"+
	  "  need for shoes.  A massive earthen fireplace takes up a large\n"+
	  "  portion of the north wall.                                   \n"
	);
	set_items(({
	    "tapestries#oriental tapestries#tapestry#oriental tapestry#"+
	    "huge tapestries#huge tapestry#hug oriental tapestry#huge "+
	    "oriental tapestry#walls#wall",
	    "The brightly colored tapestries hang proudly from the ceiling.\n"+
	    "Each one of them displays intricate designs, murals of times\n"+
	    "long forgotten, and people great and small.\n",

	    "portraits#portrait#south wall",
	    "The first portrait shows a gold dragon poised protectively over\n"+
	    "the realms.  This portrait is labeled 'Angel.'  The second one \n"+
	    "shows a smallish woman with a childlike face in a simple light \n"+
	    "brown robe. She sits quietly upon a lone rock overlooking the \n"+
	    "the land below, lost to her inner thoughts and contemplations.\n"+
	    "This one is labeled 'Alena.'  The third shows a mighty human   \n"+
	    "standing gloriously before a gathering of people proclaiming   \n"+
	    "words of wisdom and truth.  It is labeled 'Valen.'  The last   \n"+
	    "portrait displays a robed human sitting behind an oaken desk   \n"+
	    "reading and studying ancient scripts.  It is labeld 'Jheleg.'  \n",

	    "carpet#forest green carpet#green carpet#thick carpet#thick "+
	    "forest green carpet#thick green carpet",
	    "Inches thick, the carpet envelopes the feet that trod on it.   \n",

	    "massive earthen fireplace#earthen fireplace#massive fireplace#"+
	    "fireplace#fire#livid fire",
	    "Constructed of huge slabs of granite, the fireplace gives off a\n"+
	    "gentle heat generated by a livid fire that roars in its bowels.\n",
	  }));
	set_smell("The smell of fresh carpet welcomes your nose.\n");
	set_listen("The fire cackles soothingly in the fireplace.\n");
	set_weather(2, 2, 0);
	set_exits(({
	    "/players/alena/workroom",   "alena",
	    "/players/valen/workroom",   "valen",
	    "/players/jheleg/workroom",  "jhel",
	  }));
    }
}

void init() 
{
    ::init();
    if(file_size("/d/ooc/w/"+this_player()->query_real_name()+"/access.c")==-1)
    {
	write(
	  "\nYou are not an OOC domain coder and, therefore, need not\n"+
	  "concern yourself with the nature of this room.\n"
	);
	if(file_size(
	    "/players/"+this_player()->query_real_name()+"/workroom.c") > 0) 
	{
	    move_object(this_player(),
	      "/players/"+this_player()->query_real_name()+"/workroom");
	}
	else 
	{
	    move_object(this_player(),"/room/city/square");
	}
	return;
    }
}

